import 'package:flutter/material.dart';
import 'package:iroute/iroute.dart';
import 'book.dart';

//只要有appbar，则默认的，若可以pop，会出现左上的后退按钮。但appshell和app处是不能的，因为canpop在iroute下方才能引用。
class BookDetailsScreen extends StatelessWidget {
  late final Book book;
  final int id;

  BookDetailsScreen({
    required this.id,
  }) : this.book = books[id];

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(),
      body: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            ...[
              Text(book.title, style: Theme.of(context).textTheme.headline6),
              Text(book.author, style: Theme.of(context).textTheme.subtitle1),
              TextButton(
                onPressed: () {
                  Navigator.of(context).pop();
                },
                child: Text('Back'),
              ),
              TextButton(
                  onPressed: () {
                    int nextId = id + 1;
                    if (nextId > 2) nextId = 0;
                    IRouteNested.of(context).push('/book/:iid=$nextId');
                  },
                  child: Text('Next'))
            ],
          ],
        ),
      ),
    );
  }
}
