import 'package:flutter/material.dart';
import 'package:iroute/iroute.dart';
import 'book_list.dart';
import 'book_detail.dart';
import 'unknow.dart';
import 'page_settings.dart';
import 'home.dart';

var addHome = (context, child) => Home(child: child);
final Map<String, RouteBuilder> routes = {
  '_': (context, params) => Home(child: params['child'] as Widget),
  '/': (BuildContext context, Map<String, dynamic> params) => BooksListScreen(),
  '/404': (context, params) => UnknownScreen(),
  '/book/:iid': (context, params) => BookDetailsScreen(id: params['id']),
  '/settings': (context, params) => PageSettings()
};

var pageList = PageList(<String, BottomNavigationBarItem>{
  '/': BottomNavigationBarItem(icon: Icon(Icons.home), label: 'Home'),
  '/settings':
      BottomNavigationBarItem(icon: Icon(Icons.settings), label: 'Settings')
});
