import 'package:flutter/material.dart';
import 'url_parser.dart';

class PageItem {
  String defaultUrl, currentUrl;
  Widget? widget;
  BottomNavigationBarItem bottom;
  PageItem(this.defaultUrl, this.bottom) : currentUrl = defaultUrl;
}

class PageList {
  int current = 0;
  List<PageItem> pages = [];

  //获得当前页的当前url
  get url => pages[current].currentUrl;

  //根据新的url，计算页号，改变current，是否要改变内置的widget？
  changeToUrl(url) {
    var params = UrlParser.getParam(url);
    current = params.containsKey('page') ? params['page'] : 0;
  }

  //这里除了/之外，应该加入页号
  PageList(Map<String, BottomNavigationBarItem> items) {
    int i = 0;

    items.forEach((key, value) {
      var item = PageItem(key, value);
      if (item.defaultUrl != '/')
        item.defaultUrl = item.defaultUrl + ':ipage=$i';
      item.currentUrl = item.defaultUrl;
      pages.add(item);
      i++;
    });
  }
}
