class UrlParser {
  static const dynamicParams = {':ipage'};

  static String getPattern(url) {
    String pattern =
        url.replaceAllMapped(RegExp('(:[sid][^=]+)(=[^/]+)'), (match) {
      if (dynamicParams.contains(match.group(1))) return '';
      return '${match.group(1)}';
    });
    return pattern;
  }

  static Map<String, dynamic> getParam(url) {
    //support '/:iid=3/:iid1=2'
    //var regExp = RegExp('(/:[sid][^=]+)(=[^/]+)');

    //change to support‘/:iid=3:iid1=2'这样每节两个参数
    var regExp = RegExp('(:[sid][^=]+)(=[^/^:]+)');

    var result = regExp.allMatches(url);
    Map<String, dynamic> args = Map<String, dynamic>();
    for (RegExpMatch match in result) {
      //only one param：
      //var argName = match.group(1)!.substring(3);
      //var argType = match.group(1)![2];

      var argName = match.group(1)!.substring(2);
      var argType = match.group(1)![1];

      var argValue = match.group(2)!.substring(1); //去掉等号

      dynamic value;

      if (argType == 'i') value = int.tryParse(argValue);
      if (argType == 'd') value = double.tryParse(argValue);
      if (argType == 's') value = argValue;
      args[argName] = value;
    }
    return args;
  }

  //like '/:iid=1_3这样，remove_3
  static removeOrder(String url) {
    var result = url.replaceAllMapped(RegExp(r'(_[^/^_]+)$'), (match) {
      return '';
    });
    return result;
  }
}
